function xpungeSingleton () {};

xpungeSingleton.prototype =
{
	the_window_counter: 0,

	getWindowCounter: function () { return this.the_window_counter; },
	setWindowCounter: function (newValue) { this.the_window_counter = newValue; },

	QueryInterface: function (iid)
	{
		if (!iid.equals(Components.interfaces.xpungeISingleton) &&
			!iid.equals(Components.interfaces.nsISupports))
		{
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}

		return this;
	}
}


// XPCOM functions for construction and registration

var xpungeModule =
{
	myCID: Components.ID("{c7775fbc-b758-4871-b8a4-d46dadd3395c}"),
	myProgID: "@mozilla.org/xpunge-singleton-service;1",
	myCNAME: "Xpunge Singleton Component",

	firstTime: true,

	registerSelf: function (compMgr, fileSpec, location, type)
	{
		if (this.firstTime)
		{
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}

		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(this.myCID, this.myCNAME, this.myProgID, fileSpec, location, type);
	},

	unregisterSelf: function (compMgr, location, type)
	{
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.unregisterFactoryLocation(this.myCID, location);        
	},

	getClassObject : function (compMgr, cid, iid)
	{
		if (!cid.equals(this.myCID))
			throw Components.results.NS_ERROR_NO_INTERFACE

		if (!iid.equals(Components.interfaces.nsIFactory))
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

		return xpungeFactory;
	},

	canUnload: function (compMgr)
	{
		return true;
	}
};


var xpungeFactory =
{
	createInstance: function (outer, iid)
	{
            if (outer != null)
		    throw Components.results.NS_ERROR_NO_AGGREGATION;

            return (new xpungeSingleton()).QueryInterface(iid);
	}
};


function NSGetModule (compMgr, fileSpec)
{
	return xpungeModule;
}

